<?php
@session_start();

# Константа для Include
define("CONST_RUFUS", true);
# Автоподгрузка классов
function __autoload($name)
{
    include("classes/_class." . $name . ".php");
}

# Класс конфига
$config = new config;
$func = new func;
# Защита от постороннего запуска
if($config->SserverIP != $func->UserIP) exit();
# Подключение к базе данных
$db = new db($config->HostDB, $config->UserDB, $config->PassDB, $config->BaseDB);

$min = 1;
$max = 1;

if (isset($_GET['min']) && isset($_GET['max'])) {
    $min = intval($_GET['min']);
    $max = intval($_GET['max']);
}

$pcount = rand($min, $max);


function generate_user()
{
    $n1 = array('ma1', 'mr2', 'po3', 'ro4', '5ko', 'vo6', '7zo', '7ri', '5ra', '2we', 'va', 'vo', 'vu', 'su', 'fi', 'fe', 'za', 'ki', 'he', 'ha', 'hw', 've', 'vr', 'vy', 'ya', 'po', 'pe', 'pw', 'pi', 'to', 'te', 'ta', 'tk', 'ts', 'zn', 'gr', 'lo', 'la', 'es', 'ga', 'ge', 'gy', 'gu', 'gi', 'ca', 'ce', 'cw', 'cu', 'ci', 'co', 'cs', 'gu', 'Gus', 'LOL', 'mv', 'pol', 'skar', 'fg', 'pa', 'fr', 'mg', 'qw', 'av', 'rt', 'bf');
    $n2 = array('@ya.ru', '@yandex.ru', '@i.ua', '@ya.ua', '@ya.in', '@mail.ru', '@bk.ru', '@inbox.ru', '@inbox.com', '@gmail.com', '@rambler.ru');
    $n3 = array('90', '91', '92', '93', '94', '95', '96', '97', '98', '99', '2000', '1999', '1981', '1982', '1983', '1984', '1985', '1986', '1987', '1989', '091', '092', '093', '094', '777', '77', '123', '00', '01', '02', '11', '12', '13', '14', '15', '17', '20', '31', '25', '88', '66', '666', '1', '2', '3', '33', '34', '35', '07', '26', '55', '09', '100', '00', '333', '321', '123', '444', '555', '666', '911', '876', '072');
    $n4 = array('-', '.', '_');
    $n5 = array('vanya', 'vova', 'robert', 'jek', 'jeka', 'jon', 'serj', 'sergey', 'evgeniy', 'evgenii', 'ron', 'rick', 'marina', 'margo', 'marg0', 'gosha', 'g0sha', 'goshan', 'masha', 'maasha', 'maha', 'marinka', 'marina', 'marino4ka', 'marosha', 'pasha', 'pavel', 'pavlik', 'petya', 'petro', 'sasha', 'sanka', 'sanyek', 'vitos', 'vitalik', 'alisa', 'alika', 'slade', 'slon', 'sniper', 'sapper', 'saper', 'grey', 'pups', 'shon', 'azat', 'azamat', 'patrik', 'aram', 'aslan', 'marat', 'murat', 'ararat', 'purgen', 'sezam', 'krator', 'krokodil', 'barash', 'ivolga', 'anton', 'junnet', 'junett', 'melkum', 'karabas', 'polsha', 'wests', 'screag', 'gopal', 'globo', 'alicaMM', 'Fingers', 'Alamats', 'PUPUU', 'Max012', 'svetabl', 'rinatukr', 'vikavip', 'stalker51', 'stalker09', 'FFrenat', 'feliks', 'maidanu', 'trahtau', 'welton', 'aRaRaT', 'klop', 'vaz', 'unix', 'klitr', 'jaja', 'raketa', 'pulya', 'loha', 'kiber', 'jila', 'vilka', 'leyka', 'polovinova', 'rahimova', 'dinislan', 'polina', 'margaritta', 'weronika', 'rodina', 'lubochka', 'operator', 'denislan', 'wergus');

    $cn1 = count($n1) - 1;//слоги
    $cn2 = count($n2) - 1;//@ящик
    $cn3 = count($n3) - 1;//даты
    $cn4 = count($n4) - 1;//символы
    $cn5 = count($n5) - 1;//имена

    $slogs = rand(1, 2);
    $email = $name = '';
    $out = array();
    $type = rand(1, 6);
    if ($type == 1) {
        $email .= $n5[rand(0, $cn5)];
        $email .= $n3[rand(0, $cn3)];
    }
    if ($type == 2) {
        $email .= $n5[rand(0, $cn5)];
        $email .= $n1[rand(0, $cn1)];
        $email .= $n3[rand(0, $cn3)];
    }
    if ($type == 3) {
        $email .= $n3[rand(0, $cn3)];
        $email .= $n5[rand(0, $cn5)];
    }
    if ($type == 4) {
        $email .= $n1[rand(0, $cn1)];
        $email .= $n5[rand(0, $cn5)];
    }
    if ($type == 5) {
        $email .= $n5[rand(0, $cn5)];
        $email .= $n1[rand(0, $cn1)];
    }
    if ($type == 6) {
        $email .= $n1[rand(0, $cn1)];
        $email .= $n1[rand(0, $cn1)];
        $email .= $n5[rand(0, $cn5)];
    }
    $name = $email;
    $email .= $n2[rand(0, $cn2)];
    $out['email'] = $email;
    $out['name'] = $name;
    $out['pass'] = $pass = rand(100000, 999999);
    $out['time'] = time();
    return $out;
}

$db->Query("SELECT * FROM db_config WHERE id = '1' LIMIT 1");
$sonfig_site = $db->FetchArray();

for ($i = 0; $i < $pcount; $i++) {

    # Регаем пользователя
    $new_user_data = generate_user();

    $txt = file('nickname2fake.txt');
    $str = $txt[array_rand($txt)];
    unset($txt);

    # Подбираем реферала
    if(rand(1,2) == 1){
        $db->Query("SELECT id, user FROM db_users_a WHERE fake > 0 ORDER BY RAND() LIMIT 1");
        $referer_data = $db->FetchArray();
    }else{
        $db->Query("SELECT id, user FROM db_users_a WHERE id = 1");
        $referer_data = $db->FetchArray();
    }

    $nu_name = preg_replace('%[^A-Za-zА-Яа-я0-9]%', '', $str);
    if (rand(1, 2) == 1) {
        $n2 = array('@ya.ru', '@yandex.ru', '@i.ua', '@ya.ua', '@ya.in', '@mail.ru', '@bk.ru', '@inbox.ru', '@inbox.com', '@gmail.com', '@rambler.ru');
        $n3 = array('90', '91', '92', '93', '94', '95', '96', '97', '98', '99', '2000', '1999', '1981', '1982', '1983', '1984', '1985', '1986', '1987', '1989', '091', '092', '093', '094', '777', '77', '123', '00', '01', '02', '11', '12', '13', '14', '15', '17', '20', '31', '25', '88', '66', '666', '1', '2', '3', '33', '34', '35', '07', '26', '55', '09', '100', '00', '333', '321', '123', '444', '555', '666', '911', '876', '072');
        if (rand(0, 2) == 1) {
            $nu_email = $nu_name . $n3[rand(0, $cn3)];
        } else {
            $nu_email = $nu_name;
        }
        $nu_email = $nu_email . $n2[rand(0, $cn2)];
    } else {
        $nu_email = $new_user_data['email'];
    }

    $nu_pass = $new_user_data['pass'];
    $nu_time = $new_user_data['time'];

    $db->Query("SELECT COUNT(*) FROM db_users_a WHERE email = '$nu_email'");
    if ($db->FetchRow() == 0) {
        if(rand(1,3) == 1){
            $fake = 1;
        }else{
            $fake = 2;
        }
        $db->Query("INSERT INTO db_users_a (user, email, pass, referer, referer_id, date_reg, ip, fake, date_login)
		VALUES ('$nu_name','{$nu_email}','$nu_pass','{$referer_data['user']}',{$referer_data['id']},'$nu_time','0',{$fake}, ".time().")");
        $lid = $db->LastInsert();
        $db->Query("INSERT INTO db_users_b (id, user, money_b, last_sbor) VALUES ('$lid','$nu_name','0', '" . time() . "')");

        # Собираем информаци о рефералах до 6го уровня
        $db->Query("SELECT id, user, referer_id FROM db_users_a WHERE id = {$referer_data['id']}");
        $r[1] = $db->FetchArray();
        for($i=1;$i<=5;$i++){
            if(!empty($r[$i]['id'])){
                $db->Query("SELECT id, user, referer_id FROM db_users_a WHERE id = {$r[$i]['referer_id']}");
                if($db->NumRows() > 0) $r[$i+1] = $db->FetchArray();
            }
        }

        $sql_string = '';

        foreach($r as $level=>$data){
            if($data['id'] > 0) $sql_string .= "referer{$level}_id = {$data['id']}, referer{$level} = '{$data['user']}', ";
            $db->query("UPDATE db_users_c SET count_ref{$level} = count_ref{$level} + 1 WHERE id = {$data['id']}");
        }

        $db->Query("INSERT INTO db_users_c SET {$sql_string} id = {$lid}");



        # Вставляем статистику
        $db->Query("UPDATE db_stats SET all_users = all_users +1 WHERE id = '1'");

        # Настройки бонусов
        $bonus_min = 10;
        $bonus_max = 100;

        $nu_sum = rand($bonus_min, rand($bonus_min, $bonus_max));
        $nu_ddel = $nu_time + 60 * 60 * 24;
        # Вносим запись в список бонусов
        $db->Query("INSERT INTO db_bonus_list (user, user_id, sum, date_add, date_del) VALUES ('$nu_name','$lid','$nu_sum','$nu_time','$nu_ddel')");

        echo "USER: {$nu_name} [{$nu_email}] is registred!";
    }

}

?>