<?PHP

class wmset
{


    var $sets = array(array());
    var $mult = 0.0000095;
    var $pers = 30;
    var $wheel_bonus = '';
    var $set_bonus = array();

    public function __construct($config = ''){

        if ($config == '') {
            # Настройка стоимости деревьев! По порядку!
            $this->sets[1]["t_a"] = 5;
            $this->sets[1]["t_b"] = 25;
            $this->sets[1]["t_c"] = 100;
            $this->sets[1]["t_d"] = 500;
            $this->sets[1]["t_e"] = 1000;
        }else{

            $this->sets[1]["t_a"] = $config['amount_a_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_b"] = $config['amount_b_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_c"] = $config['amount_c_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_d"] = $config['amount_d_t'] / $config['ser_per_wmr'];
            $this->sets[1]["t_e"] = $config['amount_e_t'] / $config['ser_per_wmr'];

            $this->pers = intval($config['wmset_pers']);
            $this->mult = floatval($config['wmset_mult']);

            $this->wheel_bonus = $config['wheel_bonus'];
            $this->insert_bonus = $config['insert_bonus'];

            if($config['insert_setbonus'] != ''){

                $temp_array = array();
                $ws = explode(';',$config["insert_setbonus"]);
                foreach($ws as $item) {
                    $data = explode(":", $item);
                    if ($data[0] <= 0) break;
                    $counts = explode('-', $data[1]);
                    $temp_array['sum'] = $data[0];
                    $temp_array['t_a'] = intval($counts[0]);
                    $temp_array['t_b'] = intval($counts[1]);
                    $temp_array['t_c'] = intval($counts[2]);
                    $temp_array['t_d'] = intval($counts[3]);
                    $temp_array['t_e'] = intval($counts[4]);

                    $this->set_bonus[] = $temp_array;

                }

            }

        }

    }


    function SetsList(){

        unset($this->sets[0]);
        return $this->sets;

    }


    function GetSet($sum){

        $money = abs(floatval($sum));

        $ret_tree["t_a"] = 0;
        $ret_tree["t_b"] = 0;
        $ret_tree["t_c"] = 0;
        $ret_tree["t_d"] = 0;
        $ret_tree["t_e"] = 0;

        if(intval($money) > 50000) $money = 50000;

        # Бонусные билеты
        if($this->wheel_bonus != ''){
            $ret_tree["wheel"] = 0;
            $ws = explode(';',$this->wheel_bonus);
            foreach($ws as $item){
                $data = explode(":",$item);
                if($data[0] <= 0 && $data[1] <= 0) break;
                if($money >= $data[0]){
                    $ret_tree["wheel"] = $data[1];
                }
            }
        }else{
            $ret_tree["wheel"] = 0;
        }
        # Бонусный процент
        if($this->insert_bonus != ''){
            $ret_tree["persent"] = 0;
            $ws = explode(';',$this->insert_bonus);
            foreach($ws as $item){
                $data = explode(":",$item);
                if($data[0] <= 0 && $data[1] <= 0) break;
                if($money >= $data[0]){
                    $ret_tree["persent"] = $data[1];
                }
            }
        }else{
            $ret_tree["persent"] = 0;
        }

        if(empty($this->set_bonus)){

            $sum = intval(($money + 1) * (($this->pers / 100) + ($money * $this->mult)));

            #if ($sum < 20) return false;

            $ret_tree = array();

            while (true) {


                if (($sum * 0.7) >= $this->sets[1]["t_e"]) {

                    $sum = $sum - $this->sets[1]["t_e"];
                    $ret_tree["t_e"] = $ret_tree["t_e"] + 1;

                } elseif (($sum * 0.7) >= $this->sets[1]["t_d"]) {

                    $sum = $sum - $this->sets[1]["t_d"];
                    $ret_tree["t_d"] = $ret_tree["t_d"] + 1;

                } elseif (($sum * 0.7) >= $this->sets[1]["t_c"]) {

                    $sum = $sum - $this->sets[1]["t_c"];
                    $ret_tree["t_c"] = $ret_tree["t_c"] + 1;

                } elseif (($sum * 0.7) >= $this->sets[1]["t_b"]) {

                    $sum = $sum - $this->sets[1]["t_b"];
                    $ret_tree["t_b"] = $ret_tree["t_b"] + 1;

                } elseif ($sum >= $this->sets[1]["t_a"]) {

                    $sum = $sum - $this->sets[1]["t_a"];
                    $ret_tree["t_a"] = $ret_tree["t_a"] + 1;

                } else break;

            }

        }else{

            foreach($this->set_bonus as $dd){

                if($money >= $dd['sum']){

                    $ret_tree["t_a"] = $dd['t_a'];
                    $ret_tree["t_b"] = $dd['t_b'];
                    $ret_tree["t_c"] = $dd['t_c'];
                    $ret_tree["t_d"] = $dd['t_d'];
                    $ret_tree["t_e"] = $dd['t_e'];

                }

            }

        }

        return $ret_tree;

    }

}


?>