<?
header('Content-Type: application/json');

#  
@session_start();

if(!$_SESSION['admin']){
	header("Location: /");
	exit();
}

#   Include
define("CONST_RUFUS", true);

#  
function __autoload($name){ include("classes/_class.".$name.".php");}
#   
$config = new config;
#    
$db = new db($config->HostDB, $config->UserDB, $config->PassDB, $config->BaseDB);

function correctString ($string) 
{
  $search = array(
  "","","","","","","","","","","","",
  "","","","","","","","","","","",
  "","","","","","","","",""
  );
  $replace = array(
  "q","w","e","r","t","y","u","i","o","p","[","]",
  "a","s","d","f","g","h","j","k","l",";","'",
  "z","x","c","v","b","n","m",",","."
  );
  //$string = iconv("CP1251", "UTF-8", $string);
  return str_replace($search, $replace, $string);
}
function IsLogin($login, $mask = "^[a-zA-Z0-9]", $len = "{1,20}"){
	return (is_array($login)) ? false : (ereg("{$mask}{$len}$", $login)) ? $login : false;
}


if (isset($_GET['term'])){
  $returnArr = array();
  try {
	$db = new PDO("mysql:host=".$config->HostDB.";dbname=".$config->BaseDB, $config->UserDB, $config->PassDB);
	$db->query("SET CHARACTER SET utf8");
	$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	//$cap = $db->prepare("SELECT stpr_id,stpr_title FROM ncfu_stpr WHERE stpr_title LIKE :term LIMIT 0,10");
	$sql = "SELECT 
			`id`,
			`user`,
			`email`,
			INET_NTOA(db_users_a.ip) uip
			FROM 
				db_users_a
			WHERE 
				fake = 0 AND (id LIKE :term OR user LIKE :term OR email LIKE :term OR INET_NTOA(db_users_a.ip) LIKE :term)
			LIMIT 0,10";
	$cap = $db->prepare($sql);

	if(!IsLogin($_GET['term'])){
		$cap->execute(array('term' => '%'.correctString(iconv ("UTF-8", "CP1251", $_GET['term'])).'%'));
	}else{
		$cap->execute(array('term' => '%'.$_GET['term'].'%'));
	}

	while($row = $cap->fetch()) {
	  $returnArr[] =  array(	'name' => $row['user'],
					'label' => $row['id'],
					'label2' => "[ID: {$row['id']}] [LOGIN: {$row['user']}] [EMAIL: {$row['email']}] [IP: {$row['uip']}]",
					'id' => $row['id']);
	}
  } catch(PDOException $e) {
	echo 'ERROR: ' . $e->getMessage();
  }
  echo json_encode($returnArr);
}

?>