<?php
@session_start();

function toUnicodeEntities($text, $from="w") {
    $text = convert_cyr_string($text, $from, "i");
    $uni = "";
    for ($i=0, $len=strlen($text); $i<$len; $i++) {
        $char = $text{$i};
        $code = ord($char);
        $uni .= ($code>175)? "&#" . (1040+($code-176)) . ";" : $char;
    }
    return $uni;
}

$num1 = toUnicodeEntities(number_format(intval($_SESSION['bbn1']), 0, ' ', ' '));
$num2 = number_format(intval($_SESSION['bbn2']), 0, ' ', ' ');
$num3 = number_format(intval($_SESSION['bbn3']), 0, ' ', ' ');

$filename="img/hit.png";
$src_img = imagecreatefrompng($filename);

$font_file = "fonts/liveinternet.ttf";

$img_x = imagesx($src_img);
$img_y = imagesy($src_img);

$black = imagecolorallocate($src_img, 0, 0, 0);

function text($src_img,$x,$y,$color,$font,$size,$text){
    $box = imagettftext($src_img, $size, 0, $x, $y, $color,  $font, $text);
    return $box;
}

$rr = 81;
$fsize = 12;
if(isset($_GET['fs'])) $fsize = $_GET['fs'];

#  1
$box = imagettfbbox($fsize, 0, $font_file, $num1);
$width = $box[2] - $box[0];
$x = $rr - $width;
$box = text($src_img,$x,12,-$black,$font_file,$fsize, $num1);

#  2
$box = imagettfbbox($fsize, 0, $font_file, $num2);
$width = $box[2] - $box[0];
$x = $rr - $width;
$box = text($src_img,$x,20,-$black,$font_file,$fsize, $num2);

#  3
$box = imagettfbbox($fsize, 0, $font_file, $num3);
$width = $box[2] - $box[0];
$x = $rr - $width;
$box = text($src_img,$x,28,-$black,$font_file,$fsize, $num3);

imagefilter($image, IMG_FILTER_BRIGHTNESS, 0);

header ("Content-type: image/png");
imagepng($src_img);
?>