<?php
header('Content-Type: application/json'); 

#error_reporting(E_ALL);
#ini_set('display_errors', 1);

#  
session_start();

if(!isset($_SESSION['user_id']) && !isset($_SESSION['admin'])) exit('NO SUCCES');

#  
function __autoload($name){ include("classes/_class." . $name . ".php"); }

#  
$config = new config;

# 
$func = new func;

#  
$db = new db($config->HostDB, $config->UserDB, $config->PassDB, $config->BaseDB);
$db->Query("SET CHARACTER SET 'utf8'");

# 
$sonfig_site = $func->config_site($db);

$ticket_themes = explode(';',$sonfig_site['support_themes']);

$sql_data .= "`{$td['Field']}`='".strval($temp)."'";

if($sonfig_site['support'] != 1 && !isset($_SESSION['admin'])) exit('NO SUCCES');

$out_array = array();

function return_json($array){
    echo json_encode($array);
    exit();
}

include("_geolocation/SxGeo.php");
$SxGeo = new SxGeo('_geolocation/SxGeoCity.dat');

function geodata($ip){
    global $SxGeo;
    $geo_date = $SxGeo->getCityFull($ip);
    $out['country'] = $geo_date['country']['name_ru'];
    $out['city']    = $geo_date['city']['name_ru'];
    return $out;
}

$date_array = array('date_reg','date_login','vk_dateadd','last_sbor');

if($sonfig_site['support_userdata'] == 1 || isset($_SESSION['admin'])){
    $key_name_array = array(
        'id'        => 'ID ',
        'user'      => '',
        'email'     => 'E-Mail',
        'come_url'  => '',
        'referer'   => '',
        'referer_id'=> 'ID ',
        'referals'  => '',
        'date_reg'   => '',
        'date_login'   => ' ',
        'ip'   => 'IP ',
        'vk_user_id'   => 'VK ID',
        'vk_first_name'   => 'VK ',
        'vk_last_name'   => 'VK ',
        'vk_bdate'   => 'VK .',
        'vk_dateadd'   => 'VK .',
        'spam'   => '',
        'rs_referer_id'   => 'RS  ID',
        'money_b'   => '.',
        'money_p'   => '.',
        'money_r'   => '..',
        'cash_points'   => ' ',
        'curse'   => '.',
        'wheel'   => ' ',
        'a_t'   => ' ',
        'b_t'   => ' ',
        'c_t'   => ' ',
        'd_t'   => ' ',
        'e_t'   => ' ',
        'last_sbor'   => ' ',
        'from_referals'   => '..',
        'from_refvisit'   => '..',
        'payment_sum'   => '',
        'insert_sum'   => '',
        'refvisit_today'   => '   ',
        'refvisit_all'   => '   ',
    );
}else{
    $key_name_array = array(
        'id'        => 'ID ',
        'user'      => ''
    );
}


#  
$onpage = 20;

if(!empty($_GET)){

    $num_p = (isset($_GET["page"]) AND intval($_GET["page"]) < 999999999999 AND intval($_GET["page"]) >= 1) ? (intval($_GET["page"]) - 1) : 0;
    $lim = $num_p * $onpage;

    switch ($_GET['param']){

        case 'last_ticket':

            if(isset($_SESSION['admin'])){
                $db->Query("SELECT id FROM db_ticket_id ORDER BY id DESC LIMIT 1");
            }else{
                foreach ($ticket_themes AS $val){
                    if($temp != '') $temp .= ',';
                    $temp .= $val;
                }
                if($temp != ''){
                    $db->Query("SELECT id FROM db_ticket_id WHERE status = 0 AND title_id IN({$temp}) ORDER BY id DESC LIMIT 1");
                }
            }
            $out_array['return']['last_ticket_id'] = $db->FetchRow();

            $db->Query("SELECT id FROM db_ticket_full ORDER BY id DESC LIMIT 1");
            $out_array['return']['last_message_id'] = $db->FetchRow();

            $out_array['status'] = 1;

            return_json($out_array);

            break;

        case 'mess_count':

            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            $db->Query("SELECT COUNT(id) FROM db_ticket_full WHERE id_ticket = {$ticket_id}");
            $out_array['status'] = 1;
            $out_array['return']['last_message_id'] = $db->FetchRow();
            return_json($out_array);

            break;

        case 'message':

            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            #   
            $db->Query("SELECT login FROM db_ticket_id WHERE id = {$ticket_id}");
            $out_array['user'] = $db->FetchRow();
            #  
            $db->Query("SELECT * FROM db_ticket_full WHERE id_ticket = {$ticket_id} ORDER BY date");
            while ($data = $db->FetchAssoc()){
                $data['date'] = iconv('CP1251','UTF-8',$func->time2word($data['date']));
                $out_array['messages'][] = $data;
            }
            $db->Query("UPDATE db_ticket_id SET admin_read = 1 WHERE id = {$ticket_id}");
            $out_array['status'] = 1;
            return_json($out_array);

            break;

        case 'list':

            if(isset($_SESSION['admin'])){
                $db->Query("SELECT *, (SELECT COUNT(id) FROM db_ticket_full WHERE id_ticket = db_ticket_id.id) countmess FROM db_ticket_id ORDER BY status, id DESC LIMIT {$lim}, {$onpage}");
            }else{
                foreach ($ticket_themes AS $val){
                    if($temp != '') $temp .= ',';
                    $temp .= $val;
                }
                if($temp != ''){
                    $db->Query("SELECT *, (SELECT COUNT(id) FROM db_ticket_full WHERE id_ticket = db_ticket_id.id) countmess FROM db_ticket_id WHERE title_id IN({$temp}) ORDER BY status, id DESC LIMIT {$lim}, {$onpage}");
                }
            }
            while ($data = $db->FetchAssoc()){
                $data['date'] = iconv('CP1251','UTF-8',$func->time2word($data['date']));
                $out_array['message'][] = $data;
            }
            #   
            $db->Query("SELECT id FROM db_ticket_full ORDER BY id DESC LIMIT 1");
            $out_array['last_message_id'] = $db->FetchRow();

            #   
            $db->Query("SELECT id FROM db_ticket_id ORDER BY id DESC LIMIT 1");
            $out_array['last_ticket_id'] = $db->FetchRow();

            return_json($out_array);

        case 'ticket':
            
            $id = intval($_GET['id']);
            if($id > 0){
                #  
                $db->Query("SELECT * FROM db_ticket_full WHERE id_ticket = {$id} ORDER BY date");
                while ($data = $db->FetchAssoc()){
                    $data['date'] = iconv('CP1251','UTF-8',$func->time2word($data['date']));
                    $out_array['messages'][] = $data;
                }
                #   
                $db->Query("SELECT * FROM db_ticket_id WHERE id = {$id}");
                $user_data = $db->FetchAssoc();
                $out_array['ticket']['user_id'] = $user_data['user_id'];
                $out_array['ticket']['user'] = $user_data['login'];
                $out_array['ticket']['id'] = $user_data['id'];
                $out_array['ticket']['desc'] = $user_data['desc'];
                $out_array['ticket']['status'] = $user_data['status'];
                $rcurse = $func->user_curse($db,$user_data['user_id']);
                $db->Query("UPDATE db_ticket_id SET admin_read = 1 WHERE id = {$id}");
                $db->Query("SELECT *, db_users_a.id AS id, INET_NTOA(db_users_a.ip) ip FROM db_users_a LEFT JOIN db_users_b ON db_users_b.id = db_users_a.id LEFT JOIN db_users_c ON db_users_c.id = db_users_a.id LEFT JOIN db_users_d ON db_users_d.id = db_users_a.id WHERE db_users_a.id = {$user_data['user_id']}");
                foreach ($db->FetchAssoc() AS $key => $val){
                    if(!empty($key_name_array[$key])){
                        if(in_array($key,$date_array)) $val = iconv('CP1251','UTF-8',$func->time2word($val));

                        if($key == 'ip'){
                            $gd = geodata($val);
                            $out_array['userdata'][iconv('CP1251','UTF-8','')] = $gd['country'];
                            $out_array['userdata'][iconv('CP1251','UTF-8','')] = $gd['city'];
                        }else if($key == 'curse'){
                            $out_array['userdata'][iconv('CP1251','UTF-8','.')] = $rcurse;
                        }else if($key == 'money_p'){
                            $out_array['userdata'][iconv('CP1251','UTF-8','   ()')] = round(($val / $rcurse),2);
                        }else if($key == 'id' && isset($_SESSION['admin'])){
                            $val = "<a target='_blank' href='/?menu=admin4ik&sel=users&edit={$val}'>{$val}</a>";
                        }

                        $out_array['userdata'][iconv('CP1251','UTF-8',$key_name_array[$key])] = $val;

                    }else{
                        //$out_array['userdata'][$key] = $val;
                    }
                }
                #   
                $db->Query("SELECT * FROM db_insert_money WHERE user_id = {$user_data['user_id']} ORDER BY date_add DESC LIMIT 5");
                $out_array['userinsert'] = array();
                while ($data = $db->FetchAssoc()){
                    $data['date_add'] = iconv('CP1251','UTF-8',$func->time2word($data['date_add']));
                    $out_array['userinsert'][] = $data;
                }
                #    
                $db->Query("SELECT * FROM db_payments WHERE user_id = {$user_data['user_id']} ORDER BY date_add DESC LIMIT 5");
                $out_array['userpayment1'] = array();
                while ($data = $db->FetchAssoc()){
                    $data['date_add'] = iconv('CP1251','UTF-8',$func->time2word($data['date_add']));
                    $out_array['userpayment1'][] = $data;
                }
                #    
                $db->Query("SELECT * FROM db_payment_ext WHERE user_id = {$user_data['user_id']} ORDER BY date_add DESC LIMIT 5");
                $out_array['userpayment2'] = array();
                while ($data = $db->FetchAssoc()){
                    $data['date_add'] = iconv('CP1251','UTF-8',$func->time2word($data['date_add']));
                    $out_array['userpayment2'][] = $data;
                }
                #      
                $db->Query("SELECT *, INET_NTOA(ip) ip FROM db_login WHERE user_id = {$user_data['user_id']} ORDER BY id DESC LIMIT 5");
                $out_array['userlogin'] = array();
                while ($data = $db->FetchAssoc()){
                    $data['date'] = iconv('CP1251','UTF-8',$func->time2word($data['date']));
                    $data['info'] = geodata($data['ip']);
                    $out_array['userlogin'][] = $data;
                }
                #      
                $db->Query("SELECT *, (SELECT COUNT(id) FROM db_ticket_full WHERE id_ticket = db_ticket_id.id) countmess FROM db_ticket_id  WHERE user_id = {$user_data['user_id']} AND id != {$id} AND date <= {$user_data['date']} ORDER BY date DESC LIMIT 5");
                $out_array['usertickets'] = array();
                while ($data = $db->FetchAssoc()){
                    $data['date'] = iconv('CP1251','UTF-8',$func->time2word($data['date']));
                    $out_array['usertickets'][] = $data;
                }

                return_json($out_array);
                
            }else exit('ERROR TICKET_ID');

        case 'send':

            $ticket_id = intval($_GET['ticket_id']);
            $text = str_replace("\n", '<br/>', htmlspecialchars($_GET['text'], ENT_QUOTES, 'CP1251'));
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            if($text == '') exit('TEXT IS NOT NULL');
            $time = time();
            $username = iconv('CP1251','UTF-8',' ');
            $status = 0;
            $admin_id = intval($_SESSION['user_id']);
            $admin_name = strval($_SESSION['user']);

		$db->Query("INSERT INTO db_ticket_full (id_ticket, login, text, date, status, admin_id, admin_name) VALUE ({$ticket_id}, '{$username}', '{$text}', {$time}, {$status}, {$admin_id}, '{$admin_name}')");

            $out_array['mess']['id'] = $db->LastInsert();
            $out_array['mess']['id_ticket'] = $ticket_id;
            $out_array['mess']['login'] = "{$username} [{$admin_name}]";
            $out_array['mess']['text'] = $text;
            $out_array['mess']['status'] = $status;
            $out_array['mess']['date'] = iconv('CP1251','UTF-8',$func->time2word($time));

            return_json($out_array);

        case 'close':
            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            $db->Query("UPDATE db_ticket_id SET status = 1 WHERE id = {$ticket_id}");
            $out_array['status'] = 1;

            return_json($out_array);

        case 'open':
            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            $db->Query("UPDATE db_ticket_id SET status = 0 WHERE id = {$ticket_id}");
            $out_array['status'] = 1;

            return_json($out_array);

        case 'delete':
            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            $db->Query("DELETE FROM db_ticket_full WHERE id = {$ticket_id}");
            $out_array['status'] = 1;

            return_json($out_array);

        case 'template':
            $template_id = intval($_GET['template_id']);
            if($template_id == 0) exit('TEMPLATEID IS NOT NULL');
            $db->Query("SELECT news FROM db_ticket_template WHERE id = {$template_id} LIMIT 1");
            $out_array['status'] = 1;
            $out_array['return'] = $db->FetchRow();

            return_json($out_array);

        case 'showfull':
            $ticket_id = intval($_GET['ticket_id']);
            if($ticket_id == 0) exit('TICKETID IS NOT NULL');
            $db->Query("SELECT * FROM db_ticket_full WHERE id_ticket = {$ticket_id} ORDER BY date");
            $temp = '';
            while ($data = $db->FetchAssoc()){
                $data['date'] = iconv('CP1251','UTF-8',date("d.m.Y  H:i:s",$data['date']));
                $temp .= "{$data['date']} [{$data['login']}]: {$data['text']} \n \n";
            }
            $out_array['status'] = 1;
            $out_array['return'] = $temp;

            return_json($out_array);

        default: exit('ERROR PARAM');
    }

}else{
    exit('NO PARAM');
}


?>