var $wnd = $(window);
var animate = {
    tracked: [],
    offsets: []
};
Array.prototype.slice.apply($('[data-animate="true"]')).forEach(function (el) {
    el = $(el);
    animate.tracked.push(el);
    animate.offsets.push(el.offset().top + el.height() / 2);
});

jQuery(document).ready(function ($) {

    // parallax
    if (!/iPad|iPhone|iPod/.test(navigator.platform) && !/(android)/i.test(navigator.userAgent)) {
        $('.parallax-layer').parallax({
            mouseport: $(document.getElementById('parallax-mouseport'))
        });
    }

    // animations
    setTimeout(function () {
        var timing = setInterval(function () {
            requestAnimationFrame(function () {
                animate.offsets.forEach(function (offset, idx) {
                    if ($wnd.scrollTop() + $wnd.height() >= offset) {
                        animate.tracked[idx].removeClass('faded');
                        animate.tracked.splice(idx, 1);
                        animate.offsets.splice(idx, 1);
                    }
                });
                if (animate.tracked.length == 0) {
                    clearInterval(timing);
                }
            });
        }, 250);
    }, 600);

    // menu
    /* var clickEvent = ('ontouchstart' in window ? 'touchstart' : 'click');
    var menuTrigger = $('.toggleMenu');
    var menuMenu = $('.mainMenu');
    menuTrigger.on(clickEvent, function () {
        menuTrigger.toggleClass('active');
        menuMenu.toggleClass('active');
    });
    $(window).on('scroll', function () {
      menuTrigger.removeClass('active');
      menuMenu.removeClass('active');
    }); */


/* Инициализация скрипта раскрытия меню игр */

	$('.menuGamesOpenLink').click(function(){
		$('#menuGamesOuter').slideToggle(420);
		$(this).toggleClass('sliderOpen');
		return false;
	});

	$(window).scroll(function(){
		if ($('#menuGamesOuter').css('display') == 'block') {
			$('#menuGamesOuter').slideUp(420);
			$('.menuGamesOpenLink').removeClass('sliderOpen');
		}
	});



    // tips toggle
    $('.tips-item').each(function () {
        $(this).find('.tips-item-content').fadeOut(0);
        $(this).find('.tips-expand, .tips-item-bg').on('click', function () {
            var tip = $(this).parent();
            var content = tip.find('.tips-item-content');
            if (tip.hasClass('expanded')) {
                tip.removeClass('expanded');
                content.fadeOut(0);
            } else {
                tip.addClass('expanded');
                content.fadeIn(100);
            }
        });
    });

    // video
   // if (!/iPad|iPhone|iPod/.test(navigator.platform)) {

  //  }

    // screenshots carousel
    var $wnd = $(window);
    var oneSlide = $wnd.width() < 768;
    var screenshots = $('#screenshots');

    function ajustCarousel(oneSlide) {
        if (oneSlide) {
            screenshots
                .slick('setOption', 'slidesToShow', 1)
                .slick('setOption', 'slidesToScroll', 1);
        } else {
            screenshots
                .slick('setOption', 'slidesToShow', 3)
                .slick('setOption', 'slidesToScroll', 3);
        }
    }
    screenshots.slick({
        infinite: false,
        accessibility: false,
    });
    ajustCarousel(oneSlide);
    $(window).on('resize', function () {
        var checkOneSlide = $wnd.width() < 768;
        if (checkOneSlide !== oneSlide) {
            oneSlide = checkOneSlide;
            ajustCarousel(oneSlide);
        }
    });

    // photoswipe
    var pswpElement = document.querySelectorAll('.pswp')[0];
    var screenshotsImgs = Array.prototype.slice.apply($('.screenshots-slide img'))
        .map(function (img) {
            return img.src;
        });
    $('.screenshots-slide').on('click', function () {
        var src = this.querySelector('img').src;
        var options = {
            index: screenshotsImgs.indexOf(src)
        };
        var items = screenshotsImgs.map(function (src) {
            return {
                src: src,
                w: 800,
                h: 600
            };
        });
        var gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, items, options);
        gallery.init();
    });

    $('.js-stoggle').click(function () {
        $('.seo-toggle-block').slideToggle(400);
        var t = $(this).data('text');
        $(this).data('text', $(this).text());
        $(this).text(t);
        return false;
    });

});